package fr.inra.pappso.libodsstream.buffer;

import java.io.IOException;
import java.io.OutputStream;
import java.util.ArrayList;

import javax.xml.datatype.DatatypeConfigurationException;
import javax.xml.stream.XMLStreamException;

import fr.inra.pappso.libodsstream.OdsDocWriter;
import fr.inra.pappso.libodsstream.buffer.OdsSheetBuffer;


public class OdsBuffer {

	private OdsDocWriter odsDoc;
	
	private ArrayList<OdsSheetBuffer> listOdsSheetBuffer = new ArrayList<OdsSheetBuffer>();

	public OdsBuffer(String outputFilename) throws IOException, XMLStreamException, DatatypeConfigurationException {
		odsDoc = new OdsDocWriter(outputFilename);
	}

	public OdsBuffer(OutputStream out) throws IOException, XMLStreamException, DatatypeConfigurationException {
		odsDoc = new OdsDocWriter(out);
	}

	public OdsSheetBuffer newOdsSheetBuffer(String sheetName) throws Exception {
		if (sheetName == null) {
			throw new Exception("sheetName is null");
		}
		return new OdsSheetBuffer(this, sheetName);
	}

	protected void addOdsSheetBuffer(OdsSheetBuffer odsSheetBuffer) throws Exception {
		if (odsSheetBuffer == null) {
			throw new Exception("odsSheetBuffer is null");
		}
		listOdsSheetBuffer.add(odsSheetBuffer);
	}
	

	public void close() throws Exception {
		for (OdsSheetBuffer odsSheetBuffer:listOdsSheetBuffer) {
			if (odsSheetBuffer == null) {
				throw new Exception("odsSheetBuffer is null");
			}
			odsSheetBuffer.close();
		}
		
		this.odsDoc.close();
	}

	protected OdsDocWriter getOdsDoc() {
		return this.odsDoc;
	}

}
