package fr.inra.pappso.libodsstream.buffer;

import java.util.ArrayList;

import fr.inra.pappso.libodsstream.OdsDocWriter;

public class OdsLineBuffer {
	private ArrayList<Object> listItem = new ArrayList<Object>();
	OdsSheetBuffer odsSheetBuffer;

	protected OdsLineBuffer(OdsSheetBuffer odsSheetBuffer) {
		this.odsSheetBuffer = odsSheetBuffer;
		odsSheetBuffer.addOdsLineBuffer(this);
	}

	public void close() throws Exception {
		OdsDocWriter odsDoc = this.odsSheetBuffer.getOdsBuffer().getOdsDoc();
		odsDoc.writeLine();
		for (Object object : listItem) {
			odsDoc.writeCell(object);
		}
		listItem = null;
	}

	public void add(Object o) {
		listItem.add(o);
	}

	public int size() {
		return listItem.size();
	}

	public void writeAtPos(int pos, Object obj) throws Exception {
		if (pos < 0) {
			throw new Exception("pos must be positive");
		}
		if (pos >= this.size()) {
			throw new Exception("pos bigger than line size");
		}
		this.listItem.set(pos, obj);
	}

}
