package fr.inra.pappso.libodsstream.buffer;

import java.util.ArrayList;

public class OdsSheetBuffer {

	private String sheetName;
	OdsBuffer odsBuffer;
	private ArrayList<OdsLineBuffer> listOdsLineBuffer = new ArrayList<OdsLineBuffer>();

	protected OdsSheetBuffer(OdsBuffer odsBuffer, String sheetName) throws Exception {
		this.odsBuffer = odsBuffer;
		this.sheetName = sheetName;
		if (odsBuffer == null) {
			throw new Exception("odsBuffer is null");
		}
		odsBuffer.addOdsSheetBuffer(this);
	}

	public OdsLineBuffer newOdsLineBuffer() throws Exception {
		if (this == null) {
			throw new Exception("this OdsSheetBuffer is null");
		}
		return new OdsLineBuffer(this);
	}

	public void close() throws Exception {
		
		odsBuffer.getOdsDoc().writeSheet(sheetName);
		
		this.writeSheetContent();
		//odsBuffer.close();
	}

	private void writeSheetContent() throws Exception {
		for (OdsLineBuffer odsLineBuffer:listOdsLineBuffer) {
			odsLineBuffer.close();
		}
	}

	public void addOdsLineBuffer(OdsLineBuffer odsLineBuffer) {
		this.listOdsLineBuffer.add(odsLineBuffer);
	}

	protected OdsBuffer getOdsBuffer() {
		return this.odsBuffer;
	}

	
}
