package fr.inra.pappso.libodsstream.structure;

import java.io.IOException;
import java.io.OutputStreamWriter;
import java.util.zip.ZipEntry;
import java.util.zip.ZipOutputStream;


import javax.xml.stream.XMLOutputFactory;
import javax.xml.stream.XMLStreamException;
import javax.xml.stream.XMLStreamWriter;

public class ManifestXml {
	
	XMLStreamWriter writer;
	static String namespaceURI = new String ("urn:oasis:names:tc:opendocument:xmlns:manifest:1.0");

	public ManifestXml(ZipOutputStream zipOutputStream) throws IOException, XMLStreamException {
		//META-INF/
		/* manifest.xml
		 * <?xml version="1.0" encoding="UTF-8"?>
<manifest:manifest xmlns:manifest="urn:oasis:names:tc:opendocument:xmlns:manifest:1.0" manifest:version="1.2" >
 
</manifest:manifest>
		 */
		ZipEntry entry = new ZipEntry("META-INF/manifest.xml");
		zipOutputStream.putNextEntry(entry);
		
	
		XMLOutputFactory factory = XMLOutputFactory.newInstance();
		OutputStreamWriter noIndentOutput = new OutputStreamWriter(zipOutputStream,
				"UTF8");
		//XMLStreamWriter noIndentWriter = factory.createXMLStreamWriter(noIndentOutput);
		//writer = new IndentingXMLStreamWriter(noIndentWriter);
		writer = factory.createXMLStreamWriter(noIndentOutput);
		
		this.WriteHeader();
		/*
		 * <manifest:file-entry manifest:full-path="/" manifest:media-type="application/vnd.oasis.opendocument.spreadsheet"/>
 <manifest:file-entry manifest:full-path="content.xml" manifest:media-type="text/xml"/>
 <manifest:file-entry manifest:full-path="meta.xml" manifest:media-type="text/xml"/>
 <manifest:file-entry manifest:full-path="settings.xml" manifest:media-type="text/xml"/>
 <manifest:file-entry manifest:full-path="styles.xml" manifest:media-type="text/xml"/>
		 */
		writer.writeStartElement("manifest", "file-entry", namespaceURI);
		writer.writeAttribute("manifest", namespaceURI, "full-path", "/");
		writer.writeAttribute("manifest", namespaceURI, "media-type", "application/vnd.oasis.opendocument.spreadsheet");
		writer.writeEndElement();

		writer.writeStartElement("manifest", "file-entry", namespaceURI);
		writer.writeAttribute("manifest", namespaceURI, "full-path", "styles.xml");
		writer.writeAttribute("manifest", namespaceURI, "media-type", "text/xml");
		writer.writeEndElement();

		writer.writeStartElement("manifest", "file-entry", namespaceURI);
		writer.writeAttribute("manifest", namespaceURI, "full-path", "content.xml");
		writer.writeAttribute("manifest", namespaceURI, "media-type", "text/xml");
		writer.writeEndElement();

		writer.writeStartElement("manifest", "file-entry", namespaceURI);
		writer.writeAttribute("manifest", namespaceURI, "full-path", "meta.xml");
		writer.writeAttribute("manifest", namespaceURI, "media-type", "text/xml");
		writer.writeEndElement();

		//<manifest:file-entry manifest:full-path="mimetype"
		//manifest:media-type="text/plain" />
		writer.writeStartElement("manifest", "file-entry", namespaceURI);
		writer.writeAttribute("manifest", namespaceURI, "full-path", "mimetype");
		writer.writeAttribute("manifest", namespaceURI, "media-type", "text/plain");
		writer.writeEndElement();
	
		//<manifest:file-entry manifest:full-path="META-INF/manifest.xml"
		//		manifest:media-type="text/xml" />
		writer.writeStartElement("manifest", "file-entry", namespaceURI);
		writer.writeAttribute("manifest", namespaceURI, "full-path", "META-INF/manifest.xml");
		writer.writeAttribute("manifest", namespaceURI, "media-type", "text/xml");
		writer.writeEndElement();
	
		
		/*
		writer.writeStartElement("manifest", "file-entry", namespaceURI);
		writer.writeAttribute("manifest", namespaceURI, "full-path", "settings.xml");
		writer.writeAttribute("manifest", namespaceURI, "media-type", "text/xml");
		writer.writeEndElement();
*/

		this.close();
	}

	private void WriteHeader() throws XMLStreamException {
		writer.writeStartDocument("UTF-8", "1.0");
		//<manifest:manifest xmlns:manifest="urn:oasis:names:tc:opendocument:xmlns:manifest:1.0" manifest:version="1.2" >
		writer.writeStartElement("manifest", "manifest", namespaceURI);
		//writer.setPrefix("manifest", namespaceURI);
		//writer.setDefaultNamespace(namespaceURI);
		//writer.writeStartElement("mzXML");
		writer.writeNamespace("manifest", namespaceURI);
		//writer.writeDefaultNamespace(namespaceURI);

		//writer.writeAttribute(xmlnsxsi, "schemaLocation", xsischemaLocation);
		
		
		//not compatible with MS office 2010 :
		//writer.writeAttribute("manifest", namespaceURI, "version", "1.2");
		
	}

	private void close() throws XMLStreamException {
		writer.writeEndDocument();

		writer.flush();
		writer.close();
		
	}

}
