package fr.inra.pappso.xtandempipeline.thread;

import fr.inra.pappso.csv2ods.Ods2Csv;
import fr.inra.pappso.libodsstream.OdsDocWriter;
import fr.inra.pappso.xtandempipeline.MsException.StopException;
import fr.inra.pappso.xtandempipeline.class_msms.config;
import fr.inra.pappso.xtandempipeline.class_msms.Identification;
import fr.inra.pappso.xtandempipeline.output.SpreadSheets.OdsComparPaiOutput;
import fr.inra.pappso.xtandempipeline.output.SpreadSheets.OdsComparSpecificSpectraOutput;
import fr.inra.pappso.xtandempipeline.output.SpreadSheets.OdsComparSpectraOutput;

public class printing_combine extends printing_base {

	public printing_combine(config conf) {
		super(conf);
	}

	@Override
	protected void printComparPai(OdsDocWriter odsDoc) throws Exception {
		logger.debug("printComparPai begin");

		// Verification pas arrete
		if (this.isStop())
			throw new StopException("");
		this.add_current_progress();

		this.set_view("Printing compar PAI results");
		if (this.isCsv) {
			Ods2Csv ods2csv = new Ods2Csv();
			ods2csv.setSinkFilename(this.getfileout().getAbsolutePath()
					+ "_compar_pai.txt");

			odsDoc = ods2csv.getOdsDocPipedOutput();
		} else {
		}

		OdsComparPaiOutput writer = new OdsComparPaiOutput(odsDoc);
		// output.open(this.getfileout().getAbsolutePath() + "_compar.txt");
		for (Identification ident : this.identifications) {
			this.writeMsSampleName(ident, odsDoc);
			writer.write(ident);
		}
		logger.debug("printComparPai end");

		if (this.isCsv) {
			odsDoc.close();
			logger.debug("csv file closed "
					+ this.getfileout().getAbsolutePath() + "_compar_pai.txt");
		}
	}

	@Override
	protected void printComparSpectra(OdsDocWriter odsDoc) throws Exception {
		logger.debug("printComparSpectra begin");

		// Verification pas arrete
		if (this.isStop())
			throw new StopException("");
		this.add_current_progress();

		this.set_view("Printing compar spectra list results");
		if (this.isCsv) {
			Ods2Csv ods2csv = new Ods2Csv();
			ods2csv.setSinkFilename(this.getfileout().getAbsolutePath()
					+ "_compar_spectra.txt");

			odsDoc = ods2csv.getOdsDocPipedOutput();
		} else {
		}

		OdsComparSpectraOutput writer = new OdsComparSpectraOutput(odsDoc);
		// output.open(this.getfileout().getAbsolutePath() + "_compar.txt");
		for (Identification ident : this.identifications) {
			this.writeMsSampleName(ident, odsDoc);
			writer.write(ident);
		}
		logger.debug("printComparSpectra end");

		if (this.isCsv) {
			odsDoc.close();
			logger.debug("csv file closed "
					+ this.getfileout().getAbsolutePath()
					+ "_compar_spectra.txt");
		}
	}

	@Override
	protected void printComparSpecificSpectra(OdsDocWriter odsDoc)
			throws Exception {
		logger.debug("printComparSpecificSpectra begin");

		// Verification pas arrete
		if (this.isStop())
			throw new StopException("");
		this.add_current_progress();

		this.set_view("Printing compar specific spectra list results");
		if (this.isCsv) {
			Ods2Csv ods2csv = new Ods2Csv();
			ods2csv.setSinkFilename(this.getfileout().getAbsolutePath()
					+ "_compar_specific_spectra.txt");

			odsDoc = ods2csv.getOdsDocPipedOutput();
		} else {
		}

		OdsComparSpecificSpectraOutput writer = new OdsComparSpecificSpectraOutput(
				odsDoc);
		// output.open(this.getfileout().getAbsolutePath() + "_compar.txt");
		for (Identification ident : this.identifications) {
			this.writeMsSampleName(ident, odsDoc);
			writer.write(ident);
		}
		logger.debug("printComparSpecificSpectra end");

		if (this.isCsv) {
			odsDoc.close();
			logger.debug("csv file closed "
					+ this.getfileout().getAbsolutePath()
					+ "_compar_specific_spectra.txt");
		}
	}

}
